<?php
// $Id: b2search_management.php,v 1.5 2003/06/09 18:25:45 cjc Exp $
//
// B2 Enhanced Search Management
// Copyright (C) 2003 Cheng-Jih Chen -- webmaster@cjc.org
//
// This is an add-on to b2 weblog / news publishing tool
// b2 is copyright (c)2001, 2002 by Michel Valdrighi - m@tidakada.com
//
// **********************************************************************
// Copyright (C) 2003 Cheng-Jih Chen
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Cheng-Jih Chen (webmaster@cjc.org)
// *****************************************************************

$minadminlevel = 5;
$wordlimit = 50; 
$title = "Search Management";

require ("b2config.php");
require_once ($b2inc.'/b2vars.php');
require_once ($b2inc.'/b2functions.php');
require_once ('./b2header.php');
require_once ($b2inc.'/b2es.functions.php');

$b2varstoreset = array('pstring', 'indexedposts', 'unindexedposts', 'submit', 'termspage');

   for ($i=0; $i<count($b2varstoreset); $i += 1) {
      $b2var = $b2varstoreset[$i];
      if (!isset($$b2var)) {
         if (empty($HTTP_POST_VARS[$b2var])) {
            if (empty($HTTP_GET_VARS[$b2var])) {
               $$b2var = '';
            } else {
               $$b2var = $HTTP_GET_VARS[$b2var];
            }
         } else {
            $$b2var = $HTTP_POST_VARS[$b2var];
         }
      }
   }

if ($user_level < $minadminlevel) die ("Cheatin' uh? ");

$indexedposts = intval($indexedposts);
$unindexedposts = intval($unindexedposts);
$termspage = intval($termspage);

$nextterm = $termspage * $wordlimit + 1;

$db = mysql_connect($dbhost, $dbusername, $dbpassword) or die("Cannot connect to the database");
mysql_select_db($dbname) or die("Cannot select the database");

#
# Local functions
#

function b2esm_make_options( $input_array ) {

  $option_string = '<option value="none">  -none-  </option>';
  foreach ($input_array as $item) {
    $option_string .= '<option value="' . $item . '">Post ' . $item . '</option>' . "\n";
  }
  return $option_string;
}


#
# Run requests
#

$status_message = '';

if ($submit == 'add' && $unindexedposts != '' && is_int($unindexedposts) ) {
  $status_message .= 'Post ' . $unindexedposts . ' processing:<br>' ;
  $status_message .= b2es_process_post($unindexedposts);
}

if ($submit == 'delete' && $indexedposts != '' && is_int($indexedposts) ) {
  b2es_del_post_concordance($indexedposts);
  $status_message .= 'Post ' . $indexedposts . ' processing:<br>' ;
  $status_message .= 'Post deleted<br>';
}

if ($submit == 'refresh' && $indexedposts != '' && is_int($indexedposts) ) {
  b2es_del_post_concordance($indexedposts);
  $status_message .= 'Post ' . $indexedposts . ' processing:<br>' ;
  $status_message .= 'Post deleted<br>';
  $status_message .= 'Post ' . $indexedposts . ' processing:<br>' ;
  $status_message .= b2es_process_post($indexedposts);
}

#
# Gather some stats and data
#

$query  = "SELECT count(*) totalcount ";
$query .= " FROM $table_searchterm ";

$results = mysql_query($query);
if (!results) {
  $indexstats_wordcount = 'Database not initialized';
} else {
  $row = mysql_fetch_row($results);
  $indexstats_wordcount = $row[0];
}

$query  = "SELECT DISTINCT post_id ";
$query .= " FROM $table_concordance ORDER BY post_id";

$indexed_posts = array();

$results = mysql_query($query);
if (!results) {
  $indexstats_postcount = 'Database not initialized';
} else {
  $indexstats_postcount = mysql_num_rows($results);
  $row = mysql_fetch_row($results);
  while ($row = mysql_fetch_row($results)) {
    array_push($indexed_posts, $row[0]); 
  }
}

$query  = "SELECT id ";
$query .= " FROM $tableposts ORDER BY id";

$unindexed_posts = array();

$results = mysql_query($query);
if ($results) {
  $row = mysql_fetch_row($results);
  while ($row = mysql_fetch_row($results)) {
    array_push($unindexed_posts, $row[0]); 
  }
}

$unindexed_posts = array_diff($unindexed_posts, $indexed_posts);

#
# Make the select options
#

$options_indexedposts = b2esm_make_options($indexed_posts);
$options_unindexedposts = b2esm_make_options($unindexed_posts);

?>
  <?php echo $blankline ?>
  <?php echo $tabletop ?>
  <table width="95%" cellpadding="5" cellspacing="0" border="0">
  <form name="managesearch" method="post" action="<?php echo $siteurl . '/' . 'b2search_management.php'; ?>">
  <b>Manage Search Concordance</b>:
  <table width="100%" cellpadding="5" cellspacing="5"><tr>

    <td with="30%"><center>
      <b>Indexed Posts:</b><br>
      <select name="indexedposts" size="15">
        <?php echo $options_indexedposts; ?>
      </select>
    </center></td>

    <td with="30%"><center>
      <b>Unindexed Posts:</b><br>
      <select name="unindexedposts" size="15">
        <?php echo $options_unindexedposts; ?>
      </select>
    </center></td>

    <td with="40%" valign="top"><center>
      <b>Action:</b><br>

      <input type="submit" name="submit" value="add"> &nbsp;
      <input type="submit" name="submit" value="delete"> &nbsp;
      <input type="submit" name="submit" value="refresh"> &nbsp;

      </center>
      <hr>
      <b>Reference:</b><p>
      <table width="100%">
      <tr><td width="20%">
      <b>Add:</b>
      </td><td>Add the selected unindexed post to the search index.</td></tr>
      <tr><td><b>Delete:</b>
      </td><td>Delete the selected indexed post from the search index.</td></tr>
      <tr><td><b>Refresh:</b>
      </td><td>Refresh the selected indexed post in the search index.  This is the same as a Delete and Add.</td></tr>
      </table>

      <hr>
      <b>Status of last action:</b><p><?php echo $status_message; ?>

    </td>

  </tr></table>
  </form>
  </table>
  <?php echo $tablebottom ?>
  <?php echo $blankline ?>
  <?php echo $tabletop ?>

  <table width="95%" cellpadding="1" cellspacing="0" border="0">

  <b>Search Database Statistics:</b><br>
  Total words indexed: <?php echo $indexstats_wordcount; ?><br>
  Total posts indexed: <?php echo $indexstats_postcount; ?><br>
  Total posts unindexed: <?php echo count($unindexed_posts); ?><br>
  <p>

  <b><center>

  <?php if ($termspage > 1 ) {echo '<a href="' . $siteurl . '/b2search_management.php?termspage=' . ($termspage - 1) . '">(less)</a>'; } ?>
  <?php echo $nextterm . ' - ' . ($nextterm + $wordlimit); ?> Most Frequently Used Words</b>
  <?php if ($termspage < intval($indexstats_wordcount / $wordlimit) ) {echo '<a href="' . $siteurl . '/b2search_management.php?termspage=' . ($termspage + 1) . '">(more)</a>'; } ?>

  <table with="50%" cellpadding="5" cellspacing="0">
    <tr><td width="10%"><b>Rank</b></td><td width="45%"><b>Word</b></td><td width="45%"><b>Count</b></td></tr>

<?php

  $query  = "SELECT searchterm, count(*) totalcount ";
  $query .= " FROM $table_searchterm a INNER JOIN $table_concordance b ";
  $query .= "  ON a.searchterm_ID = b.searchterm_ID ";
  $query .= " GROUP BY searchterm ORDER BY totalcount DESC, searchterm LIMIT $nextterm, $wordlimit ";

  $results = mysql_query($query);

  if (!results) {
    print '<tr><td colspan="2">';
    print 'Search tables not initialized, or database could not be reached.';
    print '</td></tr>';
  } else {
    $wordcounter = $nextterm;
    while ($row = mysql_fetch_row($results)) {
      print '<tr><td>' . $wordcounter . '</td><td>';
      print '<a href="' . $siteurl . '/b2search.php?submit=search&s=' . $row[0] . '">' . $row[0] . '</a></td><td>';
      print $row[1] . '</td></tr>';
      ++$wordcounter;
    }
  }
?>
  </table>
  </center>
  </table>

